10 ON ERROR GOTO 750
20 CLS : PRINT "         Program for Calculating Impedance Values "
30 PRINT "         from 3-Meter Data. Copyright Peter Dodd, G3LDO. ": PRINT
40 PRINT "    Use this program to make a single impedance measurement, or"
50 PRINT "    to verify data before it is entered into a .DAT file."
60 PRINT "    The program assumes the value of Er (B) to be 50.": PRINT :PRINT
70 B = 50: PI = 3.1416:ENO=0
80 INPUT "     Ea   (A)  ", A
90 INPUT "     Ecz  (C)  ", C
100 INPUT "     Ec   (D)  ", D
110 INPUT "     Ez   (E)  ", E
120 PRINT "If there is more than one line of data below then the data has been corrected"
130 PRINT "Last line indicates corrected data used to determine impedance." :PRINT
140 PRINT "Ea (A)=";A; ", Ecz (C)=";C; ", Ec (D)=";D;", Ez (E)=" ;E
150 F = (B * B + C * C - A * A) / (2 * B * C)
160 IF F = 0 THEN G = PI / 2: GOTO 180
170 G = ATN(SQR(1 / (F * F) - 1)): IF F < 0 THEN G = PI - G
180 H = (C * C + D * D - E * E) / (2 * C * D)
190 IF H = 0 THEN J = PI / 2: GOTO 210
200 J = ATN(SQR(1 / (H * H) - 1)): IF H < 0 THEN J = PI - J
210 K = (A * A + B * B - C * C) / (2 * A * B)
220 IF K = 0 THEN L = PI / 2: GOTO 240
230 L = ATN(SQR(1 / (K * K) - 1)): IF K < 0 THEN L = PI - L
240 M = (D * D + E * E - C * C) / (2 * D * E)
250 IF M = 0 THEN N = PI / 2: GOTO 270
260 N = ATN(SQR(1 / (M * M) - 1)): IF M < 0 THEN N = PI - N
270 Q = ATN(B / D)
280 T = B / SIN(Q)
290 ZZ = (T * T + E * E - A * A) / (2 * T * E)
300 IF ZZ = 0 THEN P = PI / 2: GOTO 320
310 P = ATN(SQR(1 / (ZZ * ZZ) - 1)): IF ZZ < 0 THEN P = PI -P
320 S = P - Q
330 IF (L + Q) > (PI / 2) THEN S = (2 * PI) - (P + Q)
340 IF H > 0 THEN X1 = D - A * SIN(L) ELSE X1 = D + A * SIN(L)
350 X2 = E * M
360 X3 = E * COS(S)
370 R1 = A * K - B
380 R2 = E * SIN(N)
390 R3 = E * SIN(S)
400 X = (X1 + X2 + X3) / 3
410 R = (R1 + R2 + R3) / 3
420 V1 = ABS(X1 - X)
430 V2 = ABS(X2 - X)
440 V3 = ABS(X3 - X)
450 W1 = ABS(R1 - R)
460 W2 = ABS(R2 - R)
470 W3 = ABS(R3 - R)
480 IF V1 >= V2 THEN GOTO 500
490 IF V2 >= V3 THEN EX = V2: GOTO 520
500 IF V1 >= V3 THEN EX = V1: GOTO 520
510 EX = V3
520 IF W1 >= W2 THEN GOTO 550
530 IF W2 >= W3 THEN ER = W2: GOTO 570
540 ER = W3
550 IF W1 >= W3 THEN ER = W1: GOTO 570
560 ER = W3
570 IF X >= 0 THEN P$ = "+": GOTO 590
580 X = -X: P$ = "-"
590 EX = INT(10 * EX + .5) / 10
600 ER = INT(10 * ER + .5) / 10
610 R = INT(10 * R + .5) / 10
620 X = INT(10 * X + .5) / 10
630 : PRINT : PRINT : PRINT "SOLUTION"
640 PRINT "  Resistance  "; R
650 PRINT "  Reactance ", P$; X: PRINT
660 PRINT "  ERRORS"
670 PRINT "    R= (+/-) "; ER
680 PRINT "    X= (+/-) "; EX
690 PRINT : PRINT
700 INPUT "Goto Main Menu 1.  Repeat this program 2. "; AA
710 IF AA = 1 THEN CHAIN "MENU"
720 IF AA = 2 GOTO 10
730 IF AA = 3 THEN END
740 END
750 ENO = ENO+1:IF ENO >10 THEN PRINT "Error in data cannot be corrected":GOTO 700
760 IF ERL = 170 AND ERR=5 THEN C=C+1:RESUME 140
770 IF ERL = 310 AND ERR=5 THEN D=D+1:RESUME 140
