10 '###########################################################################
20 '                    MOBILE ANTENNA COUPLER SOLUTIONS
30 '                        FOR ANTENNA HEIGHT<0.2 LAMBDA
40 '                            BY JACK KUECKEN
50 '                               05/06/93
60 '          SOLVES FOR A SHUNT L ON THE ANTENNA SIDE AND A SERIES C
70 '                    MATCH TO 12.5 OHMS --SEE LINES 430 & 460
80 '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
90 CLS
100 PI=3.14159
110 KR=40*PI*PI
120 E0=1E-09/(36*PI):REM THE DIELECTRIC CONST OF FREE SPACE
130 INPUT"ENTER RADIATOR HEIGHT IN METERS";H
140 INPUT"ENTER RADIATOR RADIUS IN METERS ";RAD
150 INPUT"ENTER FREQUENCY IN MHZ ";F
160 INPUT"ENTER GROUND LOSS IN OHMS"; RG
170 INPUT"ENTER BASE CAPACITANCE IN PF";CB
180 INPUT "ENTER COIL Q";Q
190 LAMBD=300/F
200 W=2*PI*F*1000000!
210 RR=KR*(H/LAMBD)*(H/LAMBD)
220 'NOW SOLVE FOR RADIATION RESISTANCE
230 R=RR+RG
240 'NEXT SOLVE FOR ANT. CAPACITANCE BY ARRL FORMULA
250 L=H*3.28:D=2*RAD*39.37
260 DEN1=(LOG(24*L/D)-1)
270 DEN2=(1-(F*L/246)^2)
280 CA=17*L/((DEN1)*(DEN2))
290 LPRINT" ANTENNA CAPACITANCE IS ";CA;" PICOFARADS"
300 XC=1/(W*CA*1E-12)
310 LPRINT"FOR ANTENNA HEIGHT =";H;" AND RADIUS =";RAD;" METERS"
320 LPRINT"AT FREQUENCY ";F;" MHZ
330 LPRINT"RADIATION RESISTANCE =";RR;" OHMS AND ANTENNA CAPACITANCE=";CA;" PF"
340 LPRINT "BASE CAPACITANCE IS ";CB;" PF AND COIL Q=";Q
350 R=RR+RG
360 C=CA+CB
370 XN=-1/(W*C*1E-12)
380 GA=R/((R*R)+(XN*XN))
390 BA=-XN/((R*R)+(XN*XN))
400 LPRINT"ALLOWING FOR BASE CAPACITANCE AND GROUND LOSS"
410 LPRINT"ANTENNA TERMINAL IMPEDANCE IS ";R;"-J";ABS(XN);" OHMS"
420 ' NOW SOLVE FOR THE SHUNT INDUCTOR
430 B3=SQR((GA/12.5)+(GA*GA))
440 B4=B3+BA
450 GB=GA+(B4/Q)
460 B5=SQR((GB/12.5)+(GB*GB))
470 IF B5/(GB-GA)<Q THEN PRINT B5/(GB-GA):GB=.99*GB:GOTO 460
480 B6=B5+BA
490 L=1000000!/(W*B6)
500 LPRINT " THE COUPLER PARAMETERS ARE "
510 LPRINT "SHUNT INDUCTANCE IS "; L ;" MICROHENRIES"
520 X3=- B5/((GB*GB)+(B5*B5))
530 C3=-1E+12/(W*X3)
540 LPRINT "SERIES CAPACITANCE IS ";C3 ;" PICOFARADS "
550 ETAC=(GB-GA)/GB
560 ETAOA=ETAC*(RR/(RR+RG))
570 LPRINT "THE OVERALL EFFICIENCY IS ";ETAOA;" WITH ";ETAC;"BEING LOST IN THE COIL"
